VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cPictures"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Open up the Object Browser (F2), and select your project in the Project/Library
' drop-down. Navigate down the list of classes, and choose the cPictures class.
' In the "Members of cPictures" list, right-click on the NewEnum method. Select
' Properties from the popup menu, and click on the Advanced button of the dialog.
' Enter the value -4 in the Procedure ID field. This tells VB to use this function
' in a For Each construct. Also, you must also check "Hide this member" in the
' NewEnum function for it to work.

' Being the good programmer that you are, you should also use the Properties dialog
' to enter descriptions for each of the methods in the newly created class. These
' descriptions assist in product maintenance and support later in the life cycle of
' the product. Whoever inherits your code (possibly a later iteration of you) will
' thank you for taking this step.

' Before moving out of the Properties dialog, you need to look at one more choice
' in the Procedure ID field: (Default). You should assign this to only one of the
' methods of your class. Again, you should set the Item method as the default
' property to stay consistent with the standard collection.

'   This is our Colection that will hold the cPicture objects
Private mcolPics As Collection

Public Sub AddPicture(cPicture As cPicture)
    Dim strKey As String
    Dim lngCol As Long
    Dim bAdded As Boolean

    ' set an error handler
    On Error GoTo ErrorHandler
    
    Static lngKey As Long
    lngKey = lngKey + 1
    cPicture.Key = CStr(lngKey)
    
    strKey = cPicture.Key

    '******* 01.70k Start *******
'    mcolPics.Add cPicture, UCase$(strKey)
    If frmDisplay.mnuSortByDateCreated.Checked Then
        ' Add the pictures to the collection, sorting by date as we go
        If mcolPics.Count > 0 Then
            For lngCol = 1 To mcolPics.Count
                If DateDiff("s", mcolPics(lngCol).DateCreated, cPicture.DateCreated) <= 0 Then
                    ' Add the current record prior to this one
                    mcolPics.Add cPicture, UCase$(strKey), lngCol
                    bAdded = True
                    Exit For
                End If
            Next
            If Not bAdded Then
                ' The date is greater than any entry in the collection, so add it at the end
                mcolPics.Add cPicture, UCase$(strKey), , lngCol - 1
            End If
        Else
            ' This is the first one so just add it
            mcolPics.Add cPicture, UCase$(strKey)
        End If
    Else
       mcolPics.Add cPicture, UCase$(strKey)
    End If
    '******* 01.70k End *********
    
'    If mcolPics.Count = 60 Then
'        Test
'    End If
    
    Exit Sub
    
ErrorHandler:
    ' raise the error
    Err.Raise Number:=Err.Number, Source:="cPictures.AddPicture", Description:=Err.Description
    Exit Sub
End Sub

Public Function Items() As cPicture()
    Dim aryData() As cPicture
    Dim oPicture As cPicture
    Dim iIndex As Long
    
    iIndex = 0
    ReDim aryData(mcolPics.Count - 1)
    For Each oPicture In mcolPics
        Set aryData(iIndex) = oPicture
        iIndex = iIndex + 1
    Next
    
    Items = aryData
End Function

Public Function Keys() As String()
    Dim aryData() As String
    Dim oPicture As cPicture
    Dim iIndex As Long
    
    iIndex = 0
    ReDim aryData(mcolPics.Count - 1)
    For Each oPicture In mcolPics
        aryData(iIndex) = oPicture.Key
        iIndex = iIndex + 1
    Next
    
    Keys = aryData
End Function


Private Sub Class_Initialize()
    ' create new collection object
    Set mcolPics = New Collection
End Sub

Private Sub Class_Terminate()
    ' clear out the collection
    Do While mcolPics.Count
        mcolPics.Remove 1
    Loop
    
    '   reduce the reference count
    Set mcolPics = Nothing
End Sub

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
' Now it 's time to get the collection to work with the "For Each x in y"
' construct. You need to take two basic steps to make this work. First,
' create a property called NewEnum. In this property, you again rely on
' the private collection class, mcolPics, to do the heavy lifting.
' Note the unusual syntax: You wrap the method _NewEnum in square brackets,
' much the same as when you want to use a reserved word as a field name in
' ADO. Here it's not a reserved word in VB, but rather an invalid name.
' Wrapping it in square brackets lets you use it anyway.

    'this property allows you to enumerate
    'this collection with the For...Each syntax
    Err.Clear
    On Error Resume Next
    
    Set NewEnum = mcolPics.[_NewEnum]
End Property

Public Sub Remove(ByVal Key As String)
    ' set an error handler
    On Error GoTo ErrorHandler

    mcolPics.Remove UCase$(Key)
    Exit Sub

ErrorHandler:
    Err.Raise Number:=Err.Number, Source:="cPictures.Remove", Description:=Err.Description
    Exit Sub
End Sub

Public Function Exists(ByVal Key As String) As Boolean
    Dim oPicture As cPicture
    
    ' set an error handler
    On Error Resume Next
    
    ' init return to True, it will be set to False in
    '   the error handler if the Item does not exist
    Exists = True
    
    ' get the item
    Set oPicture = mcolPics.Item(UCase$(Key))
    
    ' check if it is good or not
    If Err.Number <> 0 Then
        Exists = False
    End If
End Function
'******* 01.70k Start *******
Public Function Item(ByVal Key As Long) As cPicture
Attribute Item.VB_UserMemId = 0
'Public Function Item(ByVal Key As String) As cPicture
'******* 01.70k End *********
' The Item method is the default method for your class and returns a cPicture
' object to the caller. If the system finds the item specified by the key,
' the code returns the item with the local object set to nothing to force cleanup
' of memory. If the system doesn't find the item with that key, a message box
' notifies the caller. Each user might decide to handle the error differently.
    Dim oPicture As cPicture
    
    ' set an error handler
    On Error GoTo ErrorHandler
    
    ' get the item
    Set oPicture = mcolPics.Item(Key)
    
    ' check if it is good or not
    If Not oPicture Is Nothing Then
        ' set return object reference
        Set Item = oPicture
        ' release local reference
        Set oPicture = Nothing
    End If
    Exit Function

ErrorHandler:
    MsgBox ("A Picture with the key: " & Key & " does not exist in the collection")
    Set Item = Nothing
    
    Exit Function
End Function

Public Sub RemoveAll()
    ' use the fast clear method
    If Not mcolPics Is Nothing Then
        Set mcolPics = Nothing
    End If
    ' now recreate it
    Set mcolPics = New Collection
End Sub

Public Property Get Count() As Long
    Count = mcolPics.Count
End Property


Public Sub Test()
Dim lngIndex As Long

Debug.Print "mcolPics"
For lngIndex = 1 To 20 'mcolPics.Count
    Debug.Print mcolPics(lngIndex).Key & "|" & mcolPics(lngIndex).DateCreated & "|" & Right(mcolPics(lngIndex).PicName, 15)
Next
Debug.Print "-----------------------------"
Debug.Print "mcolPictures"
For lngIndex = 1 To 20 'mcolPictures.Count
    Debug.Print mcolPictures(lngIndex).Key & "|" & mcolPictures(lngIndex).DateCreated & "|" & Right(mcolPictures(lngIndex).PicName, 15)
Next

End Sub
